/*-
 * ~~~~~~licensing~~~~~~
 * generator-api
 * ==========
 * Copyright (C) 2020 - 2021 EmDev LLC
 * ==========
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.base.generator.template.impl;

import java.util.Map;
import java.util.UUID;

import ru.entaxy.platform.base.support.CommonUtils;

public class TemplateMetadata {

	protected String id = UUID.randomUUID().toString();
	protected String name;
	protected String type = "ftl";
	protected String filename;
	protected String fullname;
	protected String path;
	protected String description = "";
	protected Map<String, String> additionalProperties;
	
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public String getExactName() {
		return name;
	}
	public String getName() {
		return CommonUtils.getValid(name, id);
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getExactFilename() {
		return filename;
	}
	public String getFilename() {
		return CommonUtils.getValid(filename, getName());
	}
	public void setFilename(String filename) {
		this.filename = filename;
	}
	public String getExactFullname() {
		return fullname;
	}
	public String getFullname() {
		return CommonUtils.getValid(fullname, getFilename() + "." + getType());
	}
	public void setFullname(String fullname) {
		this.fullname = fullname;
	}
	public String getType() {
		return type;
	}
	public void setType(String type) {
		this.type = type;
	}
	public String getExactPath() {
		return path;
	}
	public String getPath() {
		if (CommonUtils.isValid(path)) {
			if (!path.startsWith("/"))
				return TemplateProvider.TEMPLATE_PATH + "/" + path;
			else
				return path;
		}
		return TemplateProvider.TEMPLATE_PATH;
	}
	public void setPath(String path) {
		this.path = path;
	}
	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public Map<String, String> getAdditionalProperties() {
		return additionalProperties;
	}
	public void setAdditionalProperties(Map<String, String> additionalProperties) {
		this.additionalProperties = additionalProperties;
	}
	
}
